org.apache.poi.ss.formula.eval

## Interface RefEval

- All Superinterfaces:
    SheetRange, ValueEval
  All Known Implementing Classes:
    LazyRefEval, RefEvalBase

      public interface RefEval
      extends ValueEval, SheetRange

  RefEval is the super interface for Ref2D and Ref3DEval. Basically a RefEval impl should contain reference to the original ReferencePtg or Ref3DPtg as well as the final "value" resulting from the evaluation of the cell reference. Thus if the Cell has type `CellType.NUMERIC`, the contained value object should be of type NumberEval; if cell type is `CellType.STRING`, contained value object should be of type StringEval

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getColumn()` returns the zero based column index.
    `int` | `getFirstSheetIndex()` returns the first sheet index this applies to
    `ValueEval` | `getInnerValueEval(int sheetIndex)`
    `int` | `getLastSheetIndex()` returns the last sheet index this applies to, which will be the same as the first for a 2D and many 3D references
    `int` | `getNumberOfSheets()` returns the number of sheets this applies to
    `int` | `getRow()` returns the zero based row index.
    `AreaEval` | `offset(int relFirstRowIx, int relLastRowIx, int relFirstColIx, int relLastColIx)` Creates an `AreaEval` offset by a relative amount from this RefEval

- - ### Method Detail

    - #### getInnerValueEval

          ValueEval getInnerValueEval(int sheetIndex)

      Returns:
        the evaluated value of the cell referred to by this RefEval on the given sheet

    - #### getColumn

          int getColumn()

      returns the zero based column index.

    - #### getRow

          int getRow()

      returns the zero based row index.

    - #### getFirstSheetIndex

          int getFirstSheetIndex()

      returns the first sheet index this applies to
      Specified by:
        `getFirstSheetIndex` in interface `SheetRange`

    - #### getLastSheetIndex

          int getLastSheetIndex()

      returns the last sheet index this applies to, which will be the same as the first for a 2D and many 3D references
      Specified by:
        `getLastSheetIndex` in interface `SheetRange`

    - #### getNumberOfSheets

          int getNumberOfSheets()

      returns the number of sheets this applies to

    - #### offset

          AreaEval offset(int relFirstRowIx,
                          int relLastRowIx,
                          int relFirstColIx,
                          int relLastColIx)

      Creates an `AreaEval` offset by a relative amount from this RefEval

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.